package tesuji.games;

import tesuji.games.general.GameEventListener;
import tesuji.games.general.BoardChange;

/**
 	Simple test program for some Go module.
 	Output appears in the console.

 	<br><br>Creation date: (21-May-01 2:34:32 PM)<br><br>

	Product: Tesuji Software Go Library.<br><br>

	<font color="#CC6600"><font size=-1>
	Copyright (c) 2001 Tesuji Software B.V.<br>
	All rights reserved.<br><br>

	Permission is hereby granted, free of charge, to any person obtaining a
	copy of this software and associated documentation files (the
	"Software"), to deal in the Software without restriction, including
	without limitation the rights to use, copy, modify, merge, publish,
	distribute, and/or sell copies of the Software, and to permit persons
	to whom the Software is furnished to do so, provided that the above
	copyright notice(s) and this permission notice appear in all copies of
	the Software and that both the above copyright notice(s) and this
	permission notice appear in supporting documentation.<br><br>

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
	COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
	IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
	CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.<br><br>

	Except as contained in this notice, the name of a Tesuji Software
	shall not be used in advertising or otherwise to promote the sale, use
	or other dealings in this Software without prior written authorization
	of Tesuji Software.<br><br>
	<font color="#00000"><font size=+1>

	@author: Mark Boon
*/
public class TSGLTest
{
	public static void main(String[] argv)
	{
		// This is a very simple-minded listener. The idea is that a GUI
		// component can do something more fancy using the same method.
		GameEventListener eventListener = new GameEventListener()
			{
				public void addText(String text)
				{
					System.out.println(text);
				}

				public void changeBoard(int x, int y, byte value, byte oldValue)
				{
					BoardChange change = new BoardChange(x,y,value,oldValue);
					System.out.println("Board change: "+change);
				}
			};

		tesuji.games.go.computer.tactics.Ladder.testLadders(eventListener);
		tesuji.games.go.computer.tactics.Geta.testGetas(eventListener);
		tesuji.games.go.computer.evaluation.ModuleTest.test(eventListener);
	}
}