package tesuji.games.go.computer.evaluation;

import tesuji.games.general.GameEventListener;

import tesuji.games.go.GoConst;
import tesuji.games.go.GoArray;

/**
 	Play through a large number of moves to test the speed of the evaluation module.<br><br>

 	For the moment we just call the influence module, which means prisoners
 	aren't removed. A more realistic test will later actually have an
 	engine play the moves, remove the prisoners and do static evaluation.

 	<br><br>Creation date: (20-May-01 9:50:04 PM)<br><br>

	Product: Tesuji Software Go Library.<br><br>

	<font color="#CC6600"><font size=-1>
	Copyright (c) 2001 Tesuji Software B.V.<br>
	All rights reserved.<br><br>

	Permission is hereby granted, free of charge, to any person obtaining a
	copy of this software and associated documentation files (the
	"Software"), to deal in the Software without restriction, including
	without limitation the rights to use, copy, modify, merge, publish,
	distribute, and/or sell copies of the Software, and to permit persons
	to whom the Software is furnished to do so, provided that the above
	copyright notice(s) and this permission notice appear in all copies of
	the Software and that both the above copyright notice(s) and this
	permission notice appear in supporting documentation.<br><br>

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
	COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
	IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
	CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.<br><br>

	Except as contained in this notice, the name of a Tesuji Software
	shall not be used in advertising or otherwise to promote the sale, use
	or other dealings in this Software without prior written authorization
	of Tesuji Software.<br><br>
	<font color="#00000"><font size=+1>

	@author: Mark Boon
*/
public class ModuleTest
{
	public static void test(GameEventListener listener)
	{
		int[] moves = TestGames.xyMoves;
		long t1 = System.currentTimeMillis();
		long nrMoves = 0L;

		Influence influence = new Influence(19);

		listener.addText("Start influence speed-test.");	

		for (int i=0; i<10; i++)
		{
			listener.addText("Iteration "+i);
			byte color = GoConst.BLACK;
			influence.clear();
			int index = 0;
			do
			{
				int x = moves[index++];
				int y = moves[index++];
				
				if (x==-2)
				{
					color = GoConst.BLACK;
					influence.clear();
				}
				else
				{
					nrMoves++;
					influence.changeBoard(x,y,color,GoConst.EMPTY);
					influence.update();
					color = GoConst.invertColor(color);
				}
			} while (moves[index]!=-1);
		}
		
		long t2 = System.currentTimeMillis();
				
		listener.addText("Time used for "+nrMoves+" evaluations: "+(t2-t1)+" ms.");
	}
}